
/* GIF Animation Example Program */

#include <allegro.h>
#include <stdio.h>
#include "gif.h"

int main() {
  BITMAP *sprite[4], *buffer, *background, *title;

	allegro_init();
	install_keyboard();

  /* Use hicolor (16-bit) mode, because the animated GIFs do not use the
     same palette. */

  set_color_depth(16);
  if (set_gfx_mode(GFX_AUTODETECT, 640, 480, 0, 0)) {
    set_gfx_mode(GFX_TEXT, 0, 0, 0, 0);
    printf("Couldn't set video mode.\n");
    return 0;
  }

  buffer = create_bitmap(SCREEN_W, SCREEN_H);

  sprite[0] = load_gif("sprite1.gif", 0);
  sprite[1] = load_gif("sprite2.gif", 0);
  sprite[2] = load_gif("sprite3.gif", 0);
  sprite[3] = load_gif("sprite4.gif", 0);

  background = load_gif("gear.gif", 0);

  title = load_gif("title.gif", 0);

  while (!key[KEY_ESC]) {
    blit(background, buffer, 0, 0, 0, 0, background->w, background->h);

    rectfill(buffer, 80, 350, 640-80, 450, makecol(32, 32, 32));
    rect(buffer, 82, 352, 640-82, 448, makecol(196, 196, 196));

    draw_sprite(buffer, sprite[0], 100, 370);
    draw_sprite(buffer, sprite[1], 235, 370);
    draw_sprite(buffer, sprite[2], 360, 370);
    draw_sprite(buffer, sprite[3], 490, 370);

    draw_sprite(buffer, title, 160, 50);

    vsync();
    blit(buffer, screen, 0, 0, 0, 0, buffer->w, buffer->h);

    update_animation();
  }

  set_gfx_mode(GFX_TEXT, 0, 0, 0, 0);

  return 0;
}

/* Allegro WIP version needs an END_OF_MAIN macro */

#ifdef END_OF_MAIN
END_OF_MAIN()
#endif
